<?php
namespace Geral\Entities;

use \Geral\Util\Ambiente;
use Setforms2\Shared\Registry;
use \Geral\Util\DateUtil;
class Clienfilial extends Base\Clienfilial
{

    public static function salvaClientesAutomatico($cdfilial,$filialFiltrada){

        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        if($cdfilial == 'A'){
            /**
             * Todos os Clientes que não estão cadastrados na filial Logada
             * @var \Geral\Entities\Cliente $clienFilial Cliente
             */
            $clienFilial = \Geral\Entities\Cliente::getObjectsByWhere('CDCLIENTE
                     NOT IN
                 (SELECT CDCLIENTE FROM CLIENFILIAL WHERE CLIENFILIAL.CDFILIAL = ?)',array($filialFiltrada));

            foreach($clienFilial as $row){

                /**
                 * @var \Geral\Entities\Cliente $row Cliente
                 */
                $registro = new \Geral\Entities\Clienfilial();

                $cliente = $row->getCdcliente();

                $registro->setCdcliente($cliente);
                $registro->setCdfilial($filialFiltrada);
                $registro->setIdpermvendafos('N');
                $registro->setIdagrupnfgrupsv('N');
                $registro->setIdcorefeclifili('I');
                $registro->setIdconsminefecli('I');
                $registro->setIdutcontclpr('N');
                $registro->setIdutiladiant('N');
                $registro->setVrperatdesp('0');
                $registro->setIdclienprin('N');
                $registro->setIdativo('S');
                $registro->setNrorg(Ambiente::getNrorg());
                $registro->setDtinclusao(DateUtil::getDataAtual());
                $registro->setDtultatu(DateUtil::getDataAtual());
                $registro->setNrorginclusao(Ambiente::getNrorg());
                $registro->setCdoperinclusao(Ambiente::getCdOperador());
                $registro->setNrorgultatu(Ambiente::getNrorg());
                $registro->setCdoperultatu(Ambiente::getCdOperador());

                $registro->persist();

            }
            $connection->flush();
            $connection->commit();


        }
        else if(is_array($cdfilial)){

            foreach($cdfilial as $row){
                /**
                 * Todos os Clientes selecionados que não estão cadastrados na filial Logada
                 * @var \Geral\Entities\Cliente $clienFilial Cliente
                 */
                $clienFilial = \Geral\Entities\Cliente::getObjectByWhere('CDCLIENTE = ?
                             AND CDCLIENTE NOT IN
                     (SELECT CDCLIENTE FROM CLIENFILIAL WHERE CLIENFILIAL.CDFILIAL = ?)'
                    ,array($row['cdcliente'],$filialFiltrada));
                $cdcliente = $clienFilial->getCdcliente();

                    $registro = new \Geral\Entities\Clienfilial();

                    $registro->setCdcliente($cdcliente);
                    $registro->setCdfilial($filialFiltrada);
                    $registro->setIdpermvendafos('N');
                    $registro->setIdagrupnfgrupsv('N');
                    $registro->setIdcorefeclifili('I');
                    $registro->setIdconsminefecli('I');
                    $registro->setIdutcontclpr('N');
                    $registro->setIdutiladiant('N');
                    $registro->setVrperatdesp('0');
                    $registro->setIdclienprin('N');
                    $registro->setIdativo('S');
                    $registro->setNrorg(Ambiente::getNrorg());
                    $registro->setDtinclusao(DateUtil::getDataAtual());
                    $registro->setDtultatu(DateUtil::getDataAtual());
                    $registro->setNrorginclusao(Ambiente::getNrorg());
                    $registro->setCdoperinclusao(Ambiente::getCdOperador());
                    $registro->setNrorgultatu(Ambiente::getNrorg());
                    $registro->setCdoperultatu(Ambiente::getCdOperador());
                    $registro->persist();
            }
            $connection->flush();
            $connection->commit();
        }
    }

    public static function salvaClientes($linhas,$filialfiltrada)
    {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();

        $nrorg = Ambiente::getNrorg();
        foreach($linhas as $row){
                /**
                 *
                 * @var \Geral\Entities\Clienfilial $clienFilial Clienfilial
                 */
                $clienFilial = \Geral\Entities\Clienfilial::getObjectByWhere('CDCLIENTE = ? AND CDFILIAL = ? AND NRORG = ?'
                    ,array($row['CDCLIENTE'],$filialfiltrada,$nrorg));
            if($clienFilial == false){

                $clienFilial = new \Geral\Entities\Clienfilial();
                $clienFilial->setCdcliente($row['CDCLIENTE']);
                $clienFilial->setCdfilial($filialfiltrada);

            }

            $data      = DateUtil::getDataDeString($row['DTVENCONTRCLIE']);

            $clienFilial->setIdutiladiant($row['IDUTILADIANT']);
            $clienFilial->setVrperatdesp($row['VRPERATDESP']);
            $clienFilial->setIdclienprin($row['IDCLIENPRIN']);
            $clienFilial->setIdutcontclpr($row['IDUTCONTCLPR']);
            $clienFilial->setIdperiodfatc($row['IDPERIODFATC']);
            $clienFilial->setIdpermvendafos($row['IDPERMVENDAFOS']);
            $clienFilial->setCdexclienfil($row['CDEXCLIENFIL']);
            $clienFilial->setDesperfat($row['DESPERFAT']);
            $clienFilial->setIdcorefeclifili($row['IDCOREFECLIFILI']);
            $clienFilial->setIdconsminefecli($row['IDCONSMINEFECLI']);
            $clienFilial->setDtvencontrclie($data);
            $clienFilial->setNrdiaavisocven($row['NRDIAAVISOCVEN']);
            $clienFilial->setIdativo($row['IDATIVO']);
            $clienFilial->setNrorg(Ambiente::getNrorg());
            $clienFilial->setDtinclusao(DateUtil::getDataAtual());
            $clienFilial->setDtultatu(DateUtil::getDataAtual());
            $clienFilial->setNrorginclusao(Ambiente::getNrorg());
            $clienFilial->setCdoperinclusao(Ambiente::getCdOperador());
            $clienFilial->setNrorgultatu(Ambiente::getNrorg());
            $clienFilial->setCdoperultatu(Ambiente::getCdOperador());
            $clienFilial->persist();
        }
        $connection->flush();
        $connection->commit();

    }
}